﻿<Graph ClassName="TransferProcessExtC" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using PX.Data;
using PX.Objects.AP;
using PX.Objects.CR;
using PX.Objects.EP;
using PX.Objects.GL;
using PX.Objects.CS;
using PX.Objects.CM;
using PX.Objects.GL.DAC;
using PX.Objects.GL.Attributes;
using PX.Objects;
using PX.Objects.FA;
using static PX.Objects.FA.TransferProcess;

namespace PX.Objects.FA
{
    public class TransferProcessExtC : PXGraphExtension<TransferProcess>
    {
        //public override void Initialize()
        //{
        //    Base.Assets.WhereAnd<Where<FALocationHistory.employeeID, Equal<Current<TransferFilterExtC.usrFromEmployeeID>>>>();

        //    base.Initialize();
        //}

        #region Event Handlers
        public delegate void DoTransferDelegate(TransferFilter filter, List<FixedAsset> list);
        [PXOverride]
        public void DoTransfer(TransferFilter filter, List<FixedAsset> list, DoTransferDelegate baseMethod)
        {
            baseMethod(filter, list);

            var filterExt = PXCache<TransferFilter>.GetExtension<TransferFilterExtC>(filter);

            foreach (FixedAsset asset in list)
            {
                //var locHistory = PXSelectJoin<
                //    FALocationHistory,
                //    LeftJoin<FADetails,
                //        On<FADetails.locationRevID, Equal<FALocationHistory.revisionID>,
                //        And<FADetails.assetID, Equal<FALocationHistory.assetID>>>>,
                //    Where<FADetails.assetID, Equal<Required<FADetails.assetID>>>>.Select(Base, asset.AssetID);

                FADetails det = PXSelect<
                    FADetails, 
                    Where<FADetails.assetID, Equal<Required<FADetails.assetID>>>>
                    .Select(Base, asset.AssetID);

                PXDatabase.Update<FALocationHistory>(
                new PXDataFieldAssign<FALocationHistory.employeeID>(filterExt.UsrToEmployeeID),
                new PXDataFieldRestrict<FALocationHistory.revisionID>(det.LocationRevID),
                new PXDataFieldRestrict<FALocationHistory.assetID>(det.AssetID));
            }
        }
        
        public virtual IEnumerable assets()
        {
            TransferFilter filter = Base.Filter.Current;
            PXSelectBase<FixedAsset> cmd = new PXSelectJoin<FixedAsset,
                InnerJoin<FADetailsTransfer,
                    On<FixedAsset.assetID, Equal<FADetailsTransfer.assetID>>,
                InnerJoin<Branch, On<FixedAsset.branchID, Equal<Branch.branchID>>,
                LeftJoin<Account,
                    On<FixedAsset.fAAccountID, Equal<Account.accountID>>,
                LeftJoin<FALocationHistory,
                    On<FALocationHistory.assetID, Equal<FADetailsTransfer.assetID>,
                        And<FALocationHistory.revisionID, Equal<FADetailsTransfer.locationRevID>>>>>>>,
                            Where<FADetailsTransfer.status, NotEqual<FixedAssetStatus.hold>,
                                And<FADetailsTransfer.status, NotEqual<FixedAssetStatus.disposed>,
                                And<FADetailsTransfer.status, NotEqual<FixedAssetStatus.reversed>>>>>(Base);

            var filterExt = PXCache<TransferFilter>.GetExtension<TransferFilterExtC>(filter);

            if (filter.PeriodID != null)
            {
                cmd
                    .WhereAnd<
                    Where<FADetailsTransfer.transferPeriodID, IsNull, 
                        Or<FADetailsTransfer.transferPeriodID, LessEqual<Current<TransferFilter.periodID>>>>>();
            }
            if (PXAccess.FeatureInstalled<FeaturesSet.multipleCalendarsSupport>() || filter.OrganizationID != null)
            {
                cmd
                    .WhereAnd<
                    Where<Branch.organizationID, Equal<Current<TransferFilter.organizationID>>>>();
            }
            if (filter.BranchFrom != null)
            {
                cmd
                    .WhereAnd<
                    Where<FixedAsset.branchID, Equal<Current<TransferFilter.branchFrom>>>>();
            }
            if (filter.DepartmentFrom != null)
            {
                cmd
                    .WhereAnd<
                    Where<FALocationHistory.department, Equal<Current<TransferFilter.departmentFrom>>>>();
            }
            if (filter.ClassFrom != null)
            {
                cmd
                    .WhereAnd<
                    Where<FixedAsset.classID, Equal<Current<TransferFilter.classFrom>>>>();
            }
            if (filterExt.UsrFromEmployeeID != null)
            {
                cmd
                    .WhereAnd<
                    Where<FALocationHistory.employeeID, Equal<Current<TransferFilterExtC.usrFromEmployeeID>>>>();
            }


            int startRow = PXView.StartRow;
            int totalRows = 0;
            List<PXFilterRow> newFilters = new List<PXFilterRow>();
            foreach (PXFilterRow f in PXView.Filters)
            {
                if (f.DataField.ToLower() == "status")
                {
                    f.DataField = "FADetailsTransfer__Status";
                }
                newFilters.Add(f);
            }
            List<object> list = cmd.View.Select(PXView.Currents, null, PXView.Searches, PXView.SortColumns, PXView.Descendings, newFilters.ToArray(), ref startRow, PXView.MaximumRows, ref totalRows);
            PXView.StartRow = 0;
            return list;
        }
        #endregion
    }
}]]></CDATA>
</Graph>